anel<i18n lang="yml">
  en:
    all: "All"
    scan_results_per_day: "Scan results per day"
    pick_district: "Pick a district"
    pick_date: "Pick a date"
    overview: "Overview"
    assignments: "Assignments"
    scan_activity: "Scan activity"
    print: "Print"
    view_list: "List view"
    view_map: "Map view"
  nl:
    all: "Alle"
    scan_results_per_day: "Scanresultaten per dag"
    pick_district: "Kies een stadsdeel"
    pick_date: "Kies een datum"
    overview: "Overzicht"
    assignments: "Opdrachten"
    scan_activity: "Scan activiteit"
    view_list: "Lijstweergave"
    view_map: "Kaartweergave"
</i18n>

<template>
  <div :class="$style['operational-panel-tables']">
    <AmsPageTitle>
      {{ $t(contentOptions.title) }}
    </AmsPageTitle>

    <form :class="$style['prefilter']">
      <div :class="$style['prefilter-set']">
        <label
          for="district"
          :class="$style['prefilter-label']"
        >
          {{ $t("pick_district") }}
        </label>
        <AmsFilterSelect
          filter-id="district"
          :options="[
            {
              value: 'all',
              label: $t('all'),
            },
            {
              value: 'Zuidoost',
              label: 'Zuidoost',
            },
            {
              value: 'Centrum',
              label: 'Centrum',
            },
            {
              value: 'Noord',
              label: 'Noord',
            },
            {
              value: 'Westpoort',
              label: 'Westpoort',
            },
            {
              value: 'West',
              label: 'West',
            },
            {
              value: 'Nieuw-West',
              label: 'Nieuw-West',
            },
            {
              value: 'Zuid',
              label: 'Zuid',
            },
            {
              value: 'Oost',
              label: 'Oost',
            },
          ]"
          :current-value="STATE.filters.valueFor.district"
          :show-applied="false"
          @filterApplied="onSelectDistrict"
        />
      </div>

      <div :class="$style['prefilter-set']">
        <label
          for="datepicker"
          :class="$style['prefilter-label']"
        >
          {{ $t("pick_date") }}
        </label>
        <client-only>
          <AmsDatepicker
            :default-value="STATE.filters.valueFor.daterange ? new Date(STATE.filters.valueFor.daterange) : new Date()"
            :highlighted="datesHighlighted"
            :disabled-to="disabledTo"
            :disabled-from="disabledFrom"
            :disabled-date-list="disabledDateList"
            @date-input="onSelectDate"
          />
        </client-only>
      </div>
    </form>

    <AmsNav v-if="contentOptions.enableNav">
      <nuxt-link :to="localePath('/')" tabindex="-1">
        <AmsButton :variant="'underlined'">
          <span>{{ $t("overview") }}</span> <div :class="$style['numberlabel']">
            <span>
              {{ numberOfFilteredScans }}
            </span>
          </div>
        </AmsButton>
      </nuxt-link>

      <nuxt-link :to="localePath('/assignments')" tabindex="-1">
        <AmsButton :variant="'underlined'">
          <span>{{ $t("assignments") }}</span> <div :class="$style['numberlabel']">
            <span>16</span>
          </div>
        </AmsButton>
      </nuxt-link>
    </AmsNav>

    <div
      v-if="contentOptions.enableViewOptions"
      :class="$style['viewoptions']"
    >
      <AmsButton @click.native="printTable">
        <SvgIconPrint />
        <span>{{ $t("print") }}</span>
      </AmsButton>

      <AmsButtonToggleFilters
        v-if="!STATE.loaded.scans || scanRows.length > 0"
        key="filtersShow"
        :filters-open="foldoutState.openedFilters"
        @open-filters-row="togglePostFiltersRow"
      />

      <AmsButtonToggleMap
        v-if="!STATE.loaded.scans || scanRows.length > 0 ? STATE.enableMapSwitch : false"
        class="x2l:hidden"
      />
    </div>

    <template v-if="!STATE.loaded.scans || scanRows.length > 0">
      <AmsScansTable
        :rows="scanRows"
        :enable-view-options="contentOptions.enableViewOptions"
        :open-filters-row="foldoutState.openedFilters"
      >
        <template #endrow>
          <AmsPagination
            :number-of-pages="numberOfPages"
            :current-page-index="currentPageIndex"
            @to-page="toPage"
          />
        </template>
      </AmsScansTable>
    </template>
    <template v-else>
      <AmsNoScanResults />
    </template>
  </div>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  inject,
  watch,
} from "@nuxtjs/composition-api";
import { debounce, clone } from "lodash";
import VueScrollTo from "vue-scrollto";
import useRowFoldout from "~/composables/row-foldout";
import usePaginate from "~/components/_patterns/Pagination/paginate";
import useScansPrep from "~/components/Views/Operational/composables/scans-prep";

const ITEMS_PER_PAGE = 30;

export default defineComponent({
  name: "AmsOperationalPanelTables",

  components: {
    AmsPageTitle: () => import("~/components/_elements/Text/PageTitle.vue"),
    AmsButton: () => import("~/components/_elements/Form/Button.vue"),
    AmsFilterSelect: () => import("~/components/FilterInputs/FilterSelect.vue"),
    AmsDatepicker: () => import("~/components/_patterns/Form/Datepicker.vue"),
    AmsNav: () => import("~/components/_patterns/Nav/Nav.vue"),
    AmsPagination: () => import("~/components/_patterns/Pagination/Pagination.vue"),
    AmsButtonToggleFilters: () => import("~/components/Views/Operational/Buttons/ButtonToggleFilters.vue"),
    AmsButtonToggleMap: () => import("~/components/Views/Operational/Buttons/ButtonToggleMap.vue"),
    AmsNoScanResults: () => import("~/components/Views/Operational/NoScanResults.vue"),
    AmsScansTable: () => import("~/components/Views/Operational/ScansTable/ScansTable.vue"),

    // SVG's
    SvgIconPrint: () => import("~/assets/img/icons/print.svg"),
  },

  props: {
    contentOptions: {
      type: Object,
      required: true,
    },
  },

  setup () {
    const { STATE } = inject("store");
    const {
      datesHighlighted,
      fetchDaysWithScans,
      fetchScans,
      preparedScanRows,
      numberOfFilteredScans,
    } = useScansPrep();
    const {
      numberOfPages,
      currentPageIndex,
      paginatedItems,
      currentPageOfItems,
      toPage,
    } = usePaginate(preparedScanRows, ITEMS_PER_PAGE);
    const { foldoutState } = useRowFoldout();

    const disabledTo = new Date("2020-07-01");
    const disabledFrom = new Date();
    const disabledDateList = computed(() => {
      const dateArray = [];

      const currentDate = clone(disabledTo);

      while (currentDate <= new Date()) {
        dateArray.push(new Date(currentDate));

        // Use UTC date to prevent problems with time zones and DST
        currentDate.setUTCDate(currentDate.getUTCDate() + 1);
      }

      return dateArray;
    });

    /**
     * Apply the pre-filters and close the filters row as a side-effect.
     */
    function applyPreFilters (): void {
      foldoutState.openedFilters = false;

      fetchScans();
    }

    function onSelectDistrict (): void {
      fetchDaysWithScans();
      applyPreFilters();
    }

    /**
     * Store a chosen date as a date range.
     *
     * The Scan API requires a daterange; to get the results of one day
     * the end of the range is the start of the next day.
     */
    function onSelectDate ({ value }: { value: Date }): void {
      STATE.filters.valueFor.daterange = value;

      applyPreFilters();
    }

    /**
     * Open or close the (post-)filters row in the table head.
     */
    function togglePostFiltersRow (): void {
      foldoutState.openedFilters = !foldoutState.openedFilters;
    }

    /**
     * Print the data table nicely formatted with CSS `@media print`.
     */
    function printTable (): void {
      window.print();
    };

    // Scroll to opened foldout after click on row or marker on map.
    watch(
      (): string => foldoutState.openedFoldout,
      debounce((newValue): void => {
        if (newValue && foldoutState.tBody) {
          const element = foldoutState.tBody.$el.querySelector(`[data-cluster-id="${newValue}"]`);

          // If the element does not exist on the current page look in the other pages.
          if (!element) {
            const pageNumber = paginatedItems.value.findIndex((page: any[]) => {
              return page.find(item => item.cluster_location.subValue.properties.remote_id === newValue);
            });

            toPage(pageNumber);
          }

          setTimeout((): void => {
            VueScrollTo.scrollTo(`[data-cluster-id="${newValue}"]`, 500, {
              container: foldoutState.tBody.$el,
              easing: "ease-in-out",
            });
          }, 250);
        }
      }, 500, {
        leading: false,
        trailing: true,
      }),
    );

    return {
      STATE,
      foldoutState,
      numberOfFilteredScans,
      numberOfPages,
      currentPageIndex,
      scanRows: currentPageOfItems,
      toPage,
      onSelectDistrict,
      onSelectDate,
      datesHighlighted,
      disabledTo,
      disabledFrom,
      disabledDateList,
      applyPreFilters,
      togglePostFiltersRow,
      printTable,
    };
  },
});
</script>

<style lang="postcss" module>
.operational-panel-tables {
  height: 100%;
  height: calc(100vh - var(--appheader-height, 4.375rem));

  @apply overflow-x-scroll overflow-y-hidden p-4 h-screen bg-gray-100 text-left;

  @screen sm {
    padding: 30px;
  }

  &:focus {
    outline: none;
  }
}

.prefilter {
  @apply flex mb-6;

  .prefilter-set {
    max-width: 240px;

    @apply mr-4 w-1/2;
  }

  .prefilter-label {
    @apply leading-loose text-lg font-bold;
  }
}

.numberlabel {
  background-color: currentColor;
  height: 1.125rem;

  @apply flex justify-center items-center;

  span {
    padding-top: 1px;

    @apply mx-2 text-white text-xs;
  }
}

.viewoptions {
  @apply flex;

  button:not(:last-of-type) {
    margin-right: 10px;
  }
}
</style>
